<?php
/*
RSS feed for miniBB (RSS 2.0).
This file is part of miniBB. miniBB is free discussion forums/message board software, supplied with no warranties.
Check COPYING file for more details.
Copyright (C) 2004 Paul Puzyrev. www.minibb.com
Latest File Update: 2023-06-07
*/
define ('INCLUDED776',1);

if(defined('CLONE_PATH')) $clonePath=CLONE_PATH; else $clonePath='./';
if(file_exists($clonePath.'setup_options.php')) include ($clonePath.'setup_options.php'); else die('OFFLINE');
include ($pathToFiles.'rss_options.php');
include ($pathToFiles.'setup_'.$DB.'.php');
include ($pathToFiles.'bb_functions.php');

if(sizeof($displayForums)>0) $xtr=getClForums($displayForums,'where','','forum_id','or','=');

$limitInit=$limit;

if(!defined('PAGE1_OFFSET')) define('PAGE1_OFFSET', 0);

/* get forum titles */
$forumNames=array();
if($rw=db_simpleSelect(0,$Tf,'forum_id,forum_name')){
do $forumNames[$rw[0]]=$rw[1];
while($rw=db_simpleSelect(1));
}

function sanitizeRssTxt($newText, $amp=FALSE){

$newText=html_entity_decode($newText, ENT_SUBSTITUTE);

$r=array('&#039;', '&quot;', '<', '>', '&amp;', "\n", "\r");
$s=array('&#39;', '&#34;', '&#60;', '&#62;', '&#38;', ' ', ' ');

$newText=str_replace($r, $s, $newText);

$newText=preg_replace('/&([^#])/', '&amp;\\1', $newText);

if($amp) $newText=str_replace('&amp;', '&amp;amp;', $newText);

$newText=preg_replace("#[ ]{2,}#", ' ', $newText);

return $newText;
}

function limitByWords($text, $limit){

$tLng=0;
$ntNew='';

$nt=explode(' ', $text);

foreach($nt as $w){
$ntNew.=$w;
if(strlen($ntNew.' ')>=$limit){
break;
}
else $ntNew.=' ';
}

if(trim($ntNew)!=$text) {
$removeEnd=array(',', '.', '!', '?');
if(in_array(substr($ntNew, -1), $removeEnd)) $ntNew=substr($ntNew, 0, strlen($ntNew)-1);
$ntNew=$ntNew.'&#8230;';
}

return trim($ntNew);

}

$topics=array();
$topics2=array();
$topics3=array();
if($res=db_simpleSelect(0,$Tt,'topic_id, topic_title, topic_poster_name, topic_time, topic_last_post_id, forum_id, posts_count','','','',$sort,$limit)){
do{

$tid=$res[0];
$topics2[]=$res[4];
$topics3[]=$res[0];
$topics[$tid]['topic_title']=sanitizeRssTxt($res[1]);
$topics[$tid]['topic_last_post_id']=$res[4];
$topics[$tid]['forum_id']=$res[5];
$topics[$tid]['posts_count']=$res[6]-1;

}
while($res=db_simpleSelect(1));
}

$lbDate='';

$xtr=getClForums($topics3,'where','','topic_id','or','=');

$topicPosts=array();
$topicRecent=array();
$pDA=($post_sort==0?'ASC':'DESC');

if($res=db_simpleSelect(0,$Tp,'topic_id,post_text,post_time,poster_name,post_id','','','','topic_id ASC, post_id '.$pDA)){

do{

$tid=$res[0];

if(!isset($topicPosts[$tid]) and (!isset($premodPosts) OR ( isset($premodPosts) and isset($premodPosts) and is_array($premodPosts) and !in_array($res[4], $premodPosts) ) ) ){

$topicPosts[$tid]=$res[4];

$ttxt=limitByWords(sanitizeRssTxt(strip_tags(str_replace(array('<br />', '<br>'), ' ', $res[1])), TRUE), $maxTxtLength);
$topics[$tid]['post_text']=$ttxt;
$topics[$tid]['topic_time']=date('D, d M Y H:i:s O', strtotime($res[2]));
$topics[$tid]['topic_poster_name']=$res[3].'@fakemail.com';
$topics[$tid]['topic_last_post_id']=$res[4];

}

//collecting last build information
if(!isset($premodPosts) OR (isset($premodPosts) and isset($premodPosts) and is_array($premodPosts) and !in_array($res[4], $premodPosts))){
if(!isset($topicRecent[$tid]) or $topicRecent[$tid]<$res[2]) $topicRecent[$tid]=$res[2];
}

}

while($res=db_simpleSelect(1));
}

$mxTime='0000-00-00 00:00:00';
foreach($topicRecent as $tid=>$time){
if($time>$mxTime) $mxTime=$time;
}

$lbDate=date('D, d M Y H:i:s O', strtotime($mxTime));
$lmDate=gmdate('D, d M Y H:i:s', strtotime($mxTime)) . ' GMT';

$st=0;
foreach($topics as $key=>$val){
$topic_id=$key;
foreach($val as $k=>$v) $$k=$v;

if(isset($themeDesc) and in_array($topic, $themeDesc)) $vvpn=TRUE; else $vvpn=FALSE;
if($posts_count<$viewmaxreplys or $vvpn) $pagelm=PAGE1_OFFSET+1; else $pagelm=ceil(($posts_count+1)/$viewmaxreplys)+PAGE1_OFFSET;

if(isset($mod_rewrite) and $mod_rewrite) {
$link=addTopicURLPage(genTopicURL($main_url, $forum_id, $forumNames[$forum_id], $topic_id, $topic_title), ($goLastPost?$pagelm:(PAGE1_OFFSET+1)) ).($goLastPost?'#msg'.$topic_last_post_id:'');
}
else {
$link="{$main_url}/{$indexphp}action=vthread&amp;forum={$forum_id}&amp;topic={$topic_id}".($goLastPost?'&amp;page='.$pagelm.'#msg'.$topic_last_post_id:'');
}

$guid=$main_url.'/msg.php?id='.$topic_last_post_id;

if(!isset($topic_time)) continue;

if($st==0) {
$contentFeed.="<lastBuildDate>{$lbDate}</lastBuildDate>\n";
}

$contentFeed.=<<<out
<item>
<title>{$topic_title}</title>
<link>{$link}</link>
<guid isPermaLink="false">{$guid}</guid>
<description>{$post_text}</description>
<comments>{$link}</comments>
<pubDate>{$topic_time}</pubDate>
</item>

out;
$st=1;
}

$contentFeed.='</channel></rss>';

header("Content-type: text/xml");
header("Last-Modified: {$lmDate}");

echo $contentFeed;

?>